



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Oracle序列(Sequence)创建、使用、修改、删除</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Oracle序列(Sequence)创建、使用、修改、删除</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-25 00:41:31 </span>
						</div>
										<div class="post-content">
											
		<p>Oracle对象课程：序列(Sequence)创建、使用、修改、删除，序列(Sequence)是用来生成连续的整数数据的对象。序列常常用来作为主键中增长列，序列中的可以升序生成，也可以降序生成。创建序列的语法是：</p>
<p><strong>语法结构：创建序列<br /></strong></p>
<div>
<pre class="prettyprint linenums">CREATE SEQUENCE sequence_name

[START WITH num]

[INCREMENT BY increment]

[MAXVALUE num|NOMAXVALUE]

[MINVALUE num|NOMINVALUE]

[CYCLE|NOCYCLE]

[CACHE num|NOCACHE]</pre>
</div>
<p><strong>语法解析：</strong></p>
<p>① START WITH：从某一个整数开始，升序默认值是1，降序默认值是-1。</p>
<p>② INCREMENT BY：增长数。如果是正数则升序生成，如果是负数则降序生成。升序默认值是1，降序默认值是-1。</p>
<p>③ MAXVALUE：指最大值。</p>
<p>④ NOMAXVALUE：这是最大值的默认选项，升序的最大值是：1027，降序默认值是-1。</p>
<p>⑤ MINVALUE：指最小值。</p>
<p>⑥ NOMINVALUE：这是默认值选项，升序默认值是1，降序默认值是-1026。</p>
<p>⑦ CYCLE：表示如果升序达到最大值后，从最小值重新开始;如果是降序序列，达到最小值后，从最大值重新开始。</p>
<p>⑧ NOCYCLE：表示不重新开始，序列升序达到最大值、降序达到最小值后就报错。默认NOCYCLE。</p>
<p>⑨ CACHE：使用CACHE选项时，该序列会根据序列规则预生成一组序列号。保留在内存中，当使用下一个序列号时，可以更快的响应。当内存中的序列号用完时，系统再生成一组新的序列号，并保存在缓存中，这样可以提高生成序列号的效率。Oracle默认会生产20个序列号。</p>
<p>⑩ NOCACHE：不预先在内存中生成序列号。</p>
<p>案例2：创建一个从1开始，默认最大值，每次增长1的序列，要求NOCYCLE，缓存中有30个预先分配好的序列号。</p>
<p><strong>代码演示：生成序列号<br /></strong></p>
<div>
<pre class="prettyprint linenums">SQL&gt; CREATE SEQUENCE MYSEQ

    MINVALUE 

    START WITH 

    NOMAXVALUE

    INCREMENT BY 

    NOCYCLE

    CACHE 

    /

Sequence created</pre>
</div>
<p>序列创建之后，可以通过序列对象的CURRVAL和NEXTVAL两个&ldquo;伪列&rdquo;分别访问该序列的当前值和下一个值。</p>
<p><strong>代码演示：序列使用<br /></strong></p>
<div>
<pre class="prettyprint linenums">SQL&gt; SELECT MYSEQ.NEXTVAL FROM DUAL;

NEXTVAL

----------

SQL&gt; SELECT MYSEQ.NEXTVAL FROM DUAL;

NEXTVAL

----------

SQL&gt; SELECT MYSEQ.CURRVAL FROM DUAL;

CURRVAL

----------
</pre>
</div>
<p>使用ALTER SEQUENCE可以修改序列，在修改序列时有如下限制：</p>
<p>1. 不能修改序列的初始值。</p>
<p>2. 最小值不能大于当前值。</p>
<p>3. 最大值不能小于当前值。</p>
<p>使用DROP SEQUENCE命令可以删除一个序列对象。</p>
<p><strong>代码演示：序列修改和删除</strong></p>
<div>
<pre class="prettyprint linenums">SQL&gt; ALTER SEQUENCE MYSEQ<br />
    MAXVALUE 

    MINVALUE -

    /

SEQUENCE ALTERED

SQL&gt; DROP SEQUENCE MYSEQ;

SEQUENCE DROPPED
</pre>
</div>
<div>&nbsp;</div>																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/jqdwyrv9.html">小白Linux入门 一</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qx2odj8.html">将UIview描画成虚线等&period;</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jl1o4q.html">字符集和字符编码（Charset &amp;amp&semi; Encoding）</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8klpyrq.html">oracle vm virtualbox右ctrl切换显示模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8e63vjq.html">ITOO  第一个任务，新建界面</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlrnlxq.html">C语言的time&period;h解释python的time</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7md4jeq.html">Ruby用法总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/90v072m8.html">wxWidgets学习笔记&mdash;&mdash;在屏幕上画简单的图形和文字</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2we2owq.html">dll注册到GAC还是bin - sharepoint程序</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv156lxq.html">PCB设计资料：看到最后才知道是福利</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zojmkdq.html">&lbrack;UWP&rsqb;了解模板化控件&lpar;5&rpar;：VisualState</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zwkee9.html">PHP面试题：HTTP中POST、GET、PUT、DELETE方式的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/960jpp49.html">C&num;线程同步（1）- 临界区＆Lock</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5d767q.html">NYOJ-15：括号匹配（二）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7oee6x8.html">svn基本常见操作设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjvk509.html">codeSourcery交叉编译环境</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnv30gg8.html">有趣的CSS3背景 斜条纹</a>
		</li>
						<li><a href="https://www.batexi.com/a/9537wpe8.html">Object C学习笔记7-字符串NSString之一</a>
		</li>
						<li><a href="https://www.batexi.com/a/963kd439.html">解决Mysql中文乱码问题的方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwl34vz9.html">Tensorflow - Implement for a Convolutional Neural Network on MNIST&period;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/4qn2m22q.html">Hibernate主键生成策略（转）</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qxowmzq.html">MySQL优化性能my&period;cnf详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/495mr5eq.html">amCharts图表组件</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q7lo4g8.html">Linux一些零碎</a>
			</li>
						<li><a href="https://www.batexi.com/a/390jdzj8.html">2&period;Linux如何学习</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8knm338.html">动态SQL语句之sp&lowbar;executesql的使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9pkkw48.html">jvm性能监控与故障处理工具</a>
			</li>
						<li><a href="https://www.batexi.com/a/390jewj8.html">如何使用Profiler跟踪阻塞信息</a>
			</li>
						<li><a href="https://www.batexi.com/a/390jpgm8.html">shortcuts on Windows  and MacOS</a>
			</li>
						<li><a href="https://www.batexi.com/a/m967lr38.html">web前端基础知识 Dom</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
